#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include "strhide.h"

#define BUFSIZE 4096

int main(void)
{
  char  buf[BUFSIZE], buf2[BUFSIZE];
  u_int ctr;
  

  setbuf(stdout, NULL);
  while(1)
  {
    bzero(buf, BUFSIZE);
    bzero(buf2, BUFSIZE);
    
    printf("Plain String > ");
    if((ctr = read(STDIN_FILENO, buf, sizeof(buf))) < 0)
    {
      fprintf(stderr, "\nERROR: read()\n");
      continue;
    }
    if(buf[ctr-1] == '\n')
      buf[ctr-1] = 0;
        
    strcpy(buf2, StrHide(buf, ENCODE));
    printf("\nENCODE: ");
    for(ctr = 0; buf2[ctr]; ctr++)
    {
      if(buf2[ctr] == '"' || buf2[ctr] == '\\')
        putchar('\\');
      putchar(buf2[ctr]);
    }

    strcpy(buf, StrHide(buf2, DECODE));
    printf("\nDECODE: %s", buf ? buf : "ERROR");

    printf("\n---------------------------\n");
  }
  
  exit(0);
}
  