/*
** Copyright 1997 TICK (t_i_c_k@hotmail.com)
*/

#include <stdio.h>
#include "collector.h"

void main(void)
{
  col_set set1, set2;
  int result, n;
  
  CS_ZERO(set1);
  for(n = 0; n < 2; n++)
  {
    if( (result = ColInit(&set1, "127.0.0.1", 179)) < 0)
    {
      fprintf(stderr, "ERROR: ColInit()\n");
      exit(-1);
    }
    printf("Result of ColInit(): %d\n", result);
    printf("Set: 0x%X\n", set1);  
  }

  set2 = set1;
  CS_SET(3, set2);
  if( (result = ColSend(&set2, "Hallo %s Arsch%s\n", "du", "loch")) < 0 )
  {
    fprintf(stderr, "ERROR: ColSend()\n");
    exit(-1);
  }
  printf("Result of ColSend(): %d\n", result);
  printf("Set: 0x%X\n", set2);
  
  if( (result = ColClose(&set1)) < 0 )
  {
    fprintf(stderr, "ERROR: ColClose()\n");
    exit(-1);
  }
  printf("Result of ColClose(): %d\n", result);
  printf("Set: 0x%X\n", set1);
  
  exit(0);
}